Description: Fix testsuite
 rt-test.lisp was not updated to account for the new format of the test
 database introduced with "pfdietz's modifications". The failing tests are
 meant to work with an empty test database, but the code to empty the database
 is for the old, simpler format.
Author: Joseph Oswald <josephoswald@gmail.com>
Bug-Debian: https://bugs.debian.org/537501
Forwarded: no
Reviewed-by: Peter Van Eynde <pvaneynd@debian.org>
Last-Update: 2018-04-22
---
This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
--- a/rt-test.lisp
+++ b/rt-test.lisp
@@ -32,22 +32,29 @@
 (defmacro setup (&rest body)
   `(do-setup '(progn ., body)))
 
+(defmacro with-empty-test-database (&body body)
+  `(let ((regression-test::*entries* (list nil))
+	 (regression-test::*entries-table* (make-hash-table
+					    :test #'equal))
+	 (*test* nil)
+	 (regression-test::*in-test* nil))
+     (let ((regression-test::*entries-tail* regression-test::*entries*))
+       ,@body)))
+
 (defun do-setup (form)
-  (let ((*test* nil)
-        (*do-tests-when-defined* nil)
-        (rt::*entries* (list nil))
-        (rt::*in-test* nil)
-        (rt::*debug* t)
-        result)
-    (deftest t1 4 4)
-    (deftest (t 2) 4 3)
-    (values-list
-      (cons (normalize
-              (with-output-to-string (*standard-output*)
-                (setq result
-                      (multiple-value-list
-                        (catch 'rt::*debug* (eval form))))))
-            result))))
+  (with-empty-test-database
+      (let ((*do-tests-when-defined* nil)
+            (rt::*debug* t)
+            result)
+        (deftest t1 4 4)
+        (deftest (t 2) 4 3)
+        (values-list
+         (cons (normalize
+                 (with-output-to-string (*standard-output*)
+                   (setq result
+                         (multiple-value-list
+                           (catch 'rt::*debug* (eval form))))))
+               result)))))
 
 (defun normalize (string)
   (with-input-from-string (s string)
